#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <conio.h>
#include <io.h>
#include <fcntl.h>
#include <alloc.h>
#include <dos.h>
#include <ctype.h>
#include <sys\stat.h>

#include "zzdata.h"
#include "zzcode.h"

/**************/

int isZZLite; // YOU must set it ! ( or zf.open() will! )

int czdf::open( void )
{
 dfh = ::open("ZIGZAG.NSS",O_BINARY|O_RDWR);
 if (dfh==-1)
  return(-1);

 read(dfh,&head,sizeof(head));
 isZZLite = head.isZZLite;
 return(0);
}

void czdf::close( void )
{
 ::close(dfh);
}

long czdf::getsize( char *fnev )
{
 char *s;
 int c;
 s_fdentry de;

 for ( c=0,s=fnev ; (c<100) && *s!=0 ; s++,c++ ) *s=toupper(*s);

 lseek(dfh,sizeof(head),SEEK_SET);
 for ( c=0 ; c<=head.dirents ; c++ )
  {
   read(dfh,&de,sizeof(de));
   if ( strncmp(de.name,fnev,12)!=0 )
    continue;
   return(de.size);
  }

 return(-1);
}

int czdf::far_readfile( char *fnev, char huge *buf )
{
 char *s;
 int c;
 s_fdentry de;
 unsigned xx;
 char last;
 char hanyadek;
 char huge *hs;
 long chklong;

 for ( c=0,s=fnev ; (c<100) && *s!=0 ; s++,c++ ) *s=toupper(*s);

 lseek(dfh,sizeof(head),SEEK_SET);
 for ( c=0 ; c<=head.dirents ; c++ )
  {
   read(dfh,&de,sizeof(de));
   if ( strncmp(de.name,fnev,12)!=0 )
    continue;

   if ( de.size<64000 )
    {
     lseek(dfh,de.start,SEEK_SET);
     _dos_read( dfh,buf,de.size,&xx );

     last=DEFINIALTLAST;  hanyadek=0;
     decodetomb(buf,de.size,&last,&hanyadek);
     _fmemcpy(&chklong , &buf[de.size-sizeof(long)],sizeof(long) );
    }
   else
    {
     long left;
     left=de.size;
     long most;
     last=DEFINIALTLAST;  hanyadek=0;
     lseek(dfh,de.start,SEEK_SET);
     hs=buf;

     while ( left>0 )
      {
       most = (left<64000) ? left : 64000;
       left-=most;
       _dos_read( dfh,hs,most,&xx );
       decodetomb(hs,most,&last,&hanyadek);
       hs+=most;
      }
     _fmemcpy(&chklong , &hs[most-sizeof(long)],sizeof(long) );
    }
   if (chklong!=de.chksum)
    return(-2); // ERROR - file changed !!!!

   return(0);
  }
 return(-1); // file not found
}

void czdf::writetofile( char *mitfnev, char *hovafnev )
{
 char *s;
 int c;
 s_fdentry de;
 unsigned xx;
 char last;
 char hanyadek;
 long cn1,cn2;
 int fh;
 char far *buf;

 for ( c=0,s=mitfnev ; (c<100) && *s!=0 ; s++,c++ ) *s=toupper(*s);

 lseek(dfh,sizeof(head),SEEK_SET);
 for ( c=0 ; c<=head.dirents ; c++ )
  {
   read(dfh,&de,sizeof(de));
   if ( strncmp(de.name,mitfnev,12)!=0 )
    continue;

   ///-----------------------///
   buf=(char far *)farmalloc(15003);

   fh = ::open(hovafnev,O_RDWR|O_BINARY|O_TRUNC|O_CREAT,S_IREAD|S_IWRITE);
   cn1=de.size;

   lseek(dfh,de.start,SEEK_SET);
   last=DEFINIALTLAST;  hanyadek=0;
   while( cn1>0 )
    {
     cn2=(cn1>15000) ? 15000 : cn1;
     cn1-=cn2;
                                              // Ita rakta -=====[<>
     _dos_read( dfh,buf,cn2,&xx );

     decodetomb(buf,cn2,&last,&hanyadek);

     //for (d=0 ; d<cn2 ; d++ ) csum+=buf[d]; //csum+=buf[d]*((d%50)*2);

     _dos_write(fh,buf,cn2,&xx );
    }

   ::close(fh);
   farfree(buf);
   ///-----------------------///
   return;
  }
 return;
}


void czdf::far_specreadfile( char *fnev, char huge *buf , long honnan , long mennyit )
{                                                // honnan: !must be <64K!
 char *s;
 int c;
 s_fdentry de;
 unsigned xx;
 char last;
 char hanyadek;
 char huge *hs;

 for ( c=0,s=fnev ; (c<100) && *s!=0 ; s++,c++ ) *s=toupper(*s);

 lseek(dfh,sizeof(head),SEEK_SET);
 for ( c=0 ; c<=head.dirents ; c++ )
  {
   read(dfh,&de,sizeof(de));
   if ( strncmp(de.name,fnev,12)!=0 )
    continue;

   lseek(dfh,de.start,SEEK_SET);
   _dos_read( dfh,buf,honnan,&xx );
   last=DEFINIALTLAST;  hanyadek=0;
   decodetomb(buf,honnan,&last,&hanyadek);
   de.size-=honnan;
   de.start+=honnan;
   if (mennyit != 0) // -- spec read
    de.size=mennyit; // in this case last 4 byte check not available !

   if ( de.size<64000 )
    {
     lseek(dfh,de.start,SEEK_SET);
     _dos_read( dfh,buf,de.size,&xx );

     //last=DEFINIALTLAST;  hanyadek=0;
     decodetomb(buf,de.size,&last,&hanyadek);
    }
   else
    {
     long left;
     left=de.size;
     long most;
     //last=DEFINIALTLAST;  hanyadek=0;
     lseek(dfh,de.start,SEEK_SET);
     hs=buf;

     while ( left>0 )
      {
       most = (left<64000) ? left : 64000;
       left-=most;
       _dos_read( dfh,hs,most,&xx );
       decodetomb(hs,most,&last,&hanyadek);
       hs+=most;
      }
    }

   return;
  }
 return;
}
